\name{getSF2009.5}
\alias{getSF2009.5}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Extract data from ACS 2009 5-year Summary File
}
\description{
Extract data from ACS 2009 5-year Summary File
}
\usage{
getSF2009.5(summary.table, geo.filter, state, zip.file, type = "e", dictionary = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{summary.table}{
list of Summary tables to extract
}
  \item{geo.filter}{
list of geographic filters
}
  \item{state}{
two-digit state code of the zipped data files
}
  \item{zip.file}{
Name of zipped folder containing the summary tables
}
  \item{type}{
type of data to extract.  e for estimate, m for margin of error
}
  \item{dictionary}{
TRUE/FALSE: also return descriptive data dictionary?
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
Nicholas Nagle
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
\dontrun{
download.file('http://www2.census.gov/acs2009_5yr/summaryfile/2005-2009_ACSSF_By_State_All_Tables/Tennessee_All_Geographies_Not_Tracts_Block_Groups.zip',destfile='Tennessee_All_Geographies_Not_Tracts_Block_Groups.zip')
summary.table<-c('B03001','B23009')
zip.file <- 'Tennessee_All_Geographies_Not_Tracts_Block_Groups.zip'
state='tn'
geo.filter=list(SUMLEVEL='050')
Tennessee.counties <- getSF2009.5(summary.table, geo.filter, state, zip.file)
unlink('Tennessee_All_Geographies_Not_Tracts_Block_Groups.zip')
}

##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (summary.table, geo.filter, state, zip.file, type = "e", 
    dictionary = FALSE) 
{
    if (type != "e" & type != "m") 
        stop("type must be either \"e\" or \"m\".")
    load(paste(system.file(package = "UScensus"), "/data/acs2009_5_data_dict.Rdata", 
        sep = ""))
    geo.file.name <- paste("g20095", state, ".txt", sep = "")
    geo.header.con <- unz(zip.file, geo.file.name)
    geo.header <- read.fwf(geo.header.con, width = sf2009.5.geo.dict[, 
        "Field.Size"], col.names = sf2009.5.geo.dict[, "Data.Dictionary.Reference.Name"], 
        colClasses = "character")
    match.product <- rep(1, length = nrow(geo.header))
    for (i in 1:length(geo.filter)) {
        match.product <- match.product * match(geo.header[, as.character(names(geo.filter)[i])], 
            geo.filter[[i]], nomatch = 0)
    }
    select.rows <- which(match.product > 0)
    if (any(match(summary.table, sf2009.5.data.dict$table.id, 
        nomatch = 0) == 0)) {
        warning.text <- cat("Warning: Table(s) ", summary.table[(summary.table \%in\% 
            sf2009.5.data.dict$table.id) == FALSE], " were not found in the dictionary.\n")
        cat(warning.text)
    }
    dict.rows <- which(match(sf2009.5.data.dict$table.id, summary.table, 
        nomatch = 0) > 0)
    this.dictionary <- sf2009.5.data.dict[dict.rows, ]
    file.numbers <- unique(this.dictionary$seq)
    data.out <- geo.header[select.rows, ]
    row.names(data.out) <- data.out$LOGRECNO
    for (i in 1:length(file.numbers)) {
        file.name <- paste(type, "20095", state, file.numbers[i], 
            "000.txt", sep = "")
        data.file.con <- unz(zip.file, file = file.name)
        this.file <- try(read.table(data.file.con, sep = ",", 
            colClasses = "character"), silent = TRUE)
        if (class(this.file) == "try-error") {
            cat("An error was caught when opening ", file.name, 
                " Chances are that the file is empty for this state\n", 
                this.file)
            next
        }
        row.names(this.file) <- this.file$V6
        sub.this.dictionary <- this.dictionary[which(this.dictionary$seq == 
            file.numbers[i]), ]
        this.file <- this.file[, sub.this.dictionary$column, 
            drop = FALSE]
        names(this.file) <- sub.this.dictionary$field.id
        data.out <- merge(data.out, this.file, by.x = "row.names", 
            by.y = "row.names", all.x = TRUE)
        row.names(data.out) <- data.out$LOGRECNO
        data.out <- data.out[, -1, drop = FALSE]
        if (dictionary == TRUE) {
            if (i == 1) {
                dict.out <- sub.this.dictionary
            }
            else if (i > 1) 
                dict.out <- rbind(dict.out, sub.this.dictionary)
        }
    }
    if (dictionary == TRUE) 
        return(list(data = data.out, dictionary = dict.out))
    return(data.out)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
